# -*- coding: utf-8 -*-
# Generated by Django 1.11.29 on 2020-06-10 16:00
from __future__ import unicode_literals

from django.db import migrations, models
import django.db.models.deletion
import djangoldp.fields


class Migration(migrations.Migration):

    dependencies = [
        ('djangoldp_profile', '0007_auto_20200617_1817'),
        ('djangoldp_account', '0016_auto_20200610_1600'),
    ]

    def transfert_profile_info(apps, schema_editor):
        print(' profile info migration')
        Profile = apps.get_model('djangoldp_profile', 'Profile')
        Address = apps.get_model('djangoldp_profile', 'Address')
        ChatProfile = apps.get_model('djangoldp_account', 'ChatProfile')

        # iterate over all objects
        for profile in Profile.objects.all():
            print(profile.user.first_name, profile.user.last_name)

            if profile.city:
                address = Address(city=profile.city)
                address.save()
                profile.address = address

            profile.name = '{first} {last}'.format(first=profile.user.first_name, last=profile.user.last_name)
            profile.givenName = profile.user.first_name
            profile.familyName = profile.user.last_name

            chat_profile = ChatProfile.objects.get(user=profile.user)
            profile.jabberID = chat_profile.jabberID

            profile.save()

    operations = [
        migrations.CreateModel(
            name='Address',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('urlid', djangoldp.fields.LDPUrlField(blank=True, null=True, unique=True)),
                ('is_backlink', models.BooleanField(default=False, help_text='(DEPRECIATED) set automatically to indicate the Model is a backlink')),
                ('allow_create_backlink', models.BooleanField(default=True, help_text='set to False to disable backlink creation after Model save')),
                ('country', models.CharField(blank=True, max_length=255)),
                ('city', models.CharField(blank=True, max_length=255)),
            ],
            options={
                'verbose_name_plural': 'addresses',
                'abstract': False,
                'default_permissions': ('add', 'change', 'delete', 'view', 'control'),
            },
        ),
        migrations.CreateModel(
            name='Contact',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('urlid', djangoldp.fields.LDPUrlField(blank=True, null=True, unique=True)),
                ('is_backlink', models.BooleanField(default=False, help_text='(DEPRECIATED) set automatically to indicate the Model is a backlink')),
                ('allow_create_backlink', models.BooleanField(default=True, help_text='set to False to disable backlink creation after Model save')),
                ('fullName', models.CharField(max_length=255)),
                ('givenName', models.CharField(blank=True, max_length=255)),
                ('familyName', models.CharField(blank=True, max_length=255)),
                ('email', models.EmailField(blank=True, max_length=254)),
                ('phone', models.CharField(blank=True, max_length=255)),
                ('role', models.CharField(blank=True, max_length=255)),
            ],
            options={
                'abstract': False,
                'default_permissions': ('add', 'change', 'delete', 'view', 'control'),
            },
        ),
        migrations.AddField(
            model_name='profile',
            name='bio',
            field=models.CharField(blank=True, max_length=2048),
        ),
        migrations.AddField(
            model_name='profile',
            name='familyName',
            field=models.CharField(blank=True, max_length=255),
        ),
        migrations.AddField(
            model_name='profile',
            name='givenName',
            field=models.CharField(blank=True, max_length=255),
        ),
        migrations.AddField(
            model_name='profile',
            name='jabberID',
            field=models.CharField(blank=True, max_length=255, null=True),
        ),
        migrations.AddField(
            model_name='profile',
            name='name',
            field=models.CharField(blank=True, max_length=255),
        ),
        migrations.AddField(
            model_name='profile',
            name='skills',
            field=models.ManyToManyField(blank=True, to='djangoldp_skill.Skill'),
        ),
        migrations.AddField(
            model_name='profile',
            name='address',
            field=models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='profile', to='djangoldp_profile.Address'),
        ),
        migrations.RunPython(
            # Profile.city => Profile.address.city
            # User.first_name + User.last_name => Profile.name
            # User.first_name => Profile.givenName
            # User.last_name => Profile.familyName
            # ChatProfile.jabberID => Profile.jabberID
            transfert_profile_info,
        ),
        migrations.RemoveField(
            model_name='profile',
            name='city',
        ),
        
    ]
